-- $Id: adv_dbsummary.sql 2923 2012-01-07 09:58:29Z coelho $

-- -------------------------------------
-- Databases Summary
-- -------------------------------------

CREATE TABLE salix.summary_of_databases AS

SELECT
  iss.schema_name AS Concerned_Schema,
  sitc.Nb AS Table_Count,
  siac.Nb AS Attribute_Count,
  sicc.Nb AS Constraint_Count,
  IfNULL(fk_counter.Nb, 0) AS FK_Count,
  ssoaaa.Nb AS Advice_Count,
  soasevnb.nberr AS Error_Count,
  soasevnb.nbwar AS Warning_Count,
  soasevnb.nbnot AS Notice_Count,
  soasevnb.nbinf AS Info_Count
FROM SCHEMATA AS iss
JOIN salix.in_table_count AS sitc ON iss.schema_name = sitc.TSchema
JOIN salix.in_attribute_count AS siac ON iss.schema_name = siac.TSchema
-- zero constraint?
LEFT JOIN salix.in_constraint_count AS sicc ON iss.schema_name = sicc.TSchema
LEFT JOIN
    (SELECT
       sifkc.ConstraintSchema,
       count(*) AS Nb
     FROM salix.in_f_key_constraint AS sifkc
     GROUP BY sifkc.ConstraintSchema) AS fk_counter
  ON iss.schema_name = fk_counter.ConstraintSchema
JOIN salix.summary_of_advices_all_advices AS ssoaaa
  ON iss.schema_name = ssoaaa.Concerned_Schema
LEFT JOIN
( SELECT
    soa.concerned_schema,
    SUM(CASE soa.severity='error' WHEN TRUE THEN soa.Nb ELSE 0 END) AS NbErr,
    SUM(CASE soa.severity='warning' WHEN TRUE THEN soa.Nb ELSE 0 END) AS NbWar,
    SUM(CASE soa.severity='notice' WHEN TRUE THEN soa.Nb ELSE 0 END) AS NbNot,
    SUM(CASE soa.severity='information' WHEN TRUE THEN soa.Nb ELSE 0 END) AS NbInf
     FROM salix.summary_of_advices AS soa
     GROUP BY soa.concerned_schema
   )  AS soasevnb -- (..., nberr, nbwar, nbnot, nbinf)
  ON soasevnb.concerned_schema = iss.schema_name
WHERE iss.schema_name <> ALL (SELECT name FROM salix.excluded_schemas);

-- ALTER TABLE salix.summary_of_databases
--   ADD PRIMARY KEY (Concerned_Schema);
