-- $Id: adv_summary.sql 2923 2012-01-07 09:58:29Z coelho $

-- ------------------------------------------------
-- Create Salix Advice Summary
-- ------------------------------------------------

--
-- Warning Counter Table
--
-- VIEW
CREATE TABLE salix.in_warning_counter AS

-- Design
(SELECT
  'da_tables_wo_primary_key_but_unique' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_tables_wo_primary_key_but_unique AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_tables_wo_p_key_and_unique' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_tables_wo_p_key_and_unique AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_tables_w_composite_p_key' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_tables_w_composite_p_key AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_tables_w_composite_f_key' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_tables_w_composite_f_key AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_non_integer_p_key' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_non_integer_p_key AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_int_pk_but_no_other_key' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_int_pk_but_no_other_key AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_unique_nullable_attribute' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_unique_nullable_attribute AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_nullable_attribute_rate_high' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_nullable_attribute_rate_high AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_nullable_attribute_rate_quite_high' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_nullable_attribute_rate_quite_high AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_nullable_attribute_rate_too_high' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_nullable_attribute_rate_too_high AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_f_key_type_dont_match' AS Name,
  adv.ConstraintSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_f_key_type_dont_match AS adv
GROUP BY adv.ConstraintSchema)
UNION
(SELECT
  'da_f_key_match_b_diff_sizes' AS Name,
  adv.ConstraintSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_f_key_match_b_diff_sizes AS adv
GROUP BY adv.ConstraintSchema)
UNION
(SELECT
  'da_large_p_keys_referenced_by_f_key' AS Name,
  adv.ConstraintSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_large_p_keys_referenced_by_f_key AS adv
GROUP BY adv.ConstraintSchema)
UNION
(SELECT
  'da_f_key_not_ref_p_key' AS Name,
  adv.ConstraintSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_f_key_not_ref_p_key AS adv
GROUP BY adv.ConstraintSchema)
UNION
(SELECT
  'da_isolated_table' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_isolated_table AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_schema_wo_FK' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_schema_wo_FK AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_table_identifiers_length_too_short' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_table_identifiers_length_too_short AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_table_identifiers_length_quite_short' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_table_identifiers_length_quite_short AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_table_identifiers_length_short' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_table_identifiers_length_short AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_attribute_identifiers_length_too_short' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_attribute_identifiers_length_too_short AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_attribute_identifiers_length_quite_short' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_attribute_identifiers_length_quite_short AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_attribute_identifiers_length_short' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_attribute_identifiers_length_short AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_attribute_count_per_table_many' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_attribute_count_per_table_many AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_attribute_count_per_table_too_many' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_attribute_count_per_table_too_many AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_attribute_same_name_diff_types' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_attribute_same_name_diff_types AS adv
GROUP BY adv.TSchema)
UNION

-- Consistency
(SELECT
  'ca_cross_schema_src_constraints' AS Name,
  adv.ConstraintSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.ca_cross_schema_src_constraints AS adv
GROUP BY adv.ConstraintSchema)
UNION
(SELECT
  'ca_cross_schema_indexes' AS Name,
  adv.IndexSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.ca_cross_schema_indexes AS adv
GROUP BY adv.IndexSchema)
UNION
(SELECT
  'ca_cross_schema_dst_constraints' AS Name,
  adv.SourceConstraintSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.ca_cross_schema_dst_constraints AS adv
GROUP BY adv.SourceConstraintSchema)
UNION
(SELECT
  'ca_cross_schema_tables' AS Name,
  adv.SourceTableSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.ca_cross_schema_tables AS adv
GROUP BY adv.SourceTableSchema)

-- Database Version
UNION
(SELECT
  'dbva_database_is_mysql' AS Name,
  adv.schema_name AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.dbva_database_is_mysql AS adv
GROUP BY adv.schema_name)
UNION
(SELECT
  'dbva_table_engine_is_unsafe' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.dbva_table_engine_is_unsafe AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'dbva_schema_engine_is_unsafe' AS Name,
  adv.TSchema AS Concerned_Schema,
  1 AS Nb
FROM salix.dbva_schema_engine_is_unsafe AS adv)
UNION
(SELECT
  'dbva_engine_inconsistency' AS Name,
  adv.TSchema AS Concerned_Schema,
  1 AS Nb
FROM salix.dbva_engine_inconsistency AS adv)

UNION
(SELECT
  'da_schema_identifiers_length_too_short' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_schema_identifiers_length_too_short AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_schema_identifiers_length_quite_short' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_schema_identifiers_length_quite_short AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_schema_identifiers_length_short' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_schema_identifiers_length_short AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_table_names_mixed_style' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_table_names_mixed_style AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_attribute_names_mixed_style' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_attribute_names_mixed_style AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_attribute_pseudo_null_default' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_attribute_pseudo_null_default AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'sa_redundant_indexes' AS Name,
  adv.TSchema AS Concerned_Schema,
  SUM(Nb) AS Nb
FROM salix.sa_redundant_indexes AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'sa_table_without_index' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.sa_table_without_index AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'sa_redundant_foreign_keys' AS Name,
  adv.TSchema AS Concerned_Schema,
  SUM(Nb) AS Nb
FROM salix.sa_redundant_foreign_keys AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'sa_trivial_password_user' AS Name,
  '*' AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.sa_trivial_password_user AS adv)
UNION
(SELECT
  'sa_trivial_password_superuser' AS Name,
  '*' AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.sa_trivial_password_superuser AS adv)
UNION
(SELECT
  'da_attribute_with_table_prefix' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_attribute_with_table_prefix AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_no_attribute_table' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_no_attribute_table AS adv
GROUP BY adv.TSchema)
UNION
(SELECT
  'da_single_attribute_table' AS Name,
  adv.TSchema AS Concerned_Schema,
  COUNT(*) AS Nb
FROM salix.da_single_attribute_table AS adv
GROUP BY adv.TSchema);

-- ALTER TABLE salix.in_warning_counter
--   ADD PRIMARY KEY (Name,Concerned_Schema);

--
-- Summary of Advices per Schema
--
-- VIEW
CREATE TABLE salix.summary_of_advices AS
SELECT
  wc.Concerned_Schema,
  ak.description AS Category,
  ase.description AS Severity,
  al.description AS Level,
  wc.Nb,
  ai.title AS Title,
  ai.abstract AS Abstract,
  ai.description AS Description,
  ai.view_name AS View_Name,
  ai.cid,
  ai.sid,
  ai.lid
FROM salix.advice_info AS ai
JOIN salix.advice_category AS ak ON ai.cid=ak.cid
JOIN salix.advice_severity AS ase ON ai.sid=ase.sid
JOIN salix.advice_level AS al ON ai.lid=al.lid
JOIN salix.in_warning_counter AS wc ON ai.view_name=wc.Name
WHERE ai.active
ORDER BY wc.Concerned_Schema ASC,
   ai.cid ASC, ai.sid DESC, ai.lid ASC, wc.Nb DESC, Title ASC;

-- ALTER TABLE salix.summary_of_advices
--   ADD PRIMARY KEY (Concerned_Schema,Title);

--
-- Summary of Advices - global summary on all schemas
--
-- VIEW
CREATE TABLE salix.summary_of_advices_all_schemas AS
SELECT
  soa.Category,
  soa.Severity,
  soa.Level,
  SUM(soa.Nb) AS Nb,
  COUNT(DISTINCT soa.Concerned_Schema) AS NbSc,
  soa.Title,
  soa.Abstract,
  soa.Description,
  soa.View_Name,
  -- ??? needed for ORDER BY
  soa.cid,
  soa.sid,
  soa.lid
FROM salix.summary_of_advices AS soa
GROUP BY soa.cid, soa.Category, soa.sid, soa.Severity, soa.lid, soa.Level,
    soa.Title, soa.Abstract, soa.Description, soa.View_Name
ORDER BY soa.cid ASC, soa.sid DESC, soa.lid ASC, Nb DESC, soa.Title ASC;

-- ALTER TABLE salix.summary_of_advices_all_schemas
--   ADD PRIMARY KEY (Title);

--
-- Summary of Advices _ All advices
--
-- VIEW
CREATE TABLE salix.summary_of_advices_all_advices AS
SELECT
  soa.Concerned_Schema,
  SUM(soa.Nb) AS Nb
FROM salix.summary_of_advices AS soa
GROUP BY soa.Concerned_Schema
ORDER BY soa.Concerned_Schema ASC, Nb DESC;

-- ALTER TABLE salix.summary_of_advices_all_advices
--   ADD PRIMARY KEY (Concerned_Schema);
