-- $Id: marks.sql 2923 2012-01-07 09:58:29Z coelho $

-- --------------------------------------
-- Quality Computation
-- --------------------------------------

CREATE TABLE salix.marks(
 -- really TEXT, but MySQL cannot stand it
  schema_name VARCHAR(100) PRIMARY KEY,
  table_count INT NOT NULL,
  attribute_count INT NOT NULL,
  mark FLOAT NOT NULL
);

INSERT INTO salix.marks(schema_name,table_count,attribute_count,mark)
SELECT
  sdb.concerned_schema,
   -- they seem to be needed...
  sdb.table_count,
  sdb.attribute_count,
  -- global mark taking into account severity and level
  10.0
   -- errors
   - 2.5 *
     SUM(CASE WHEN sad.lid=1 AND sad.sid=4 THEN sad.Nb ELSE 0 END) -- schema 
   - (5.0 / sdb.table_count) *
     SUM(CASE WHEN sad.lid=2 AND sad.sid=4 THEN sad.Nb ELSE 0 END) -- tables
   - (10.0 / sdb.attribute_count) *
     SUM(CASE WHEN sad.lid=3 AND sad.sid=4 THEN sad.Nb ELSE 0 END) -- attributes
   -- warnings (including the MySQL-exclusive MyISAM warning)
   - 1.0 *
     SUM(CASE WHEN sad.lid=1 AND sad.sid=3 THEN sad.Nb ELSE 0 END) -- schema
   - (2.0 / sdb.table_count) *
     SUM(CASE WHEN sad.lid=2 AND sad.sid=3 THEN sad.Nb ELSE 0 END) -- tables
   - (4.0 / sdb.attribute_count) *
     SUM(CASE WHEN sad.lid=3 AND sad.sid=3 THEN sad.Nb ELSE 0 END) -- attributes
   -- notices
   - 0.2 *
     SUM(CASE WHEN sad.lid=1 AND sad.sid=2 THEN sad.Nb ELSE 0 END) -- schema 
   - (0.4 / sdb.table_count) *
     SUM(CASE WHEN sad.lid=2 AND sad.sid=2 THEN sad.Nb ELSE 0 END) -- tables
   - (0.8 / sdb.attribute_count) *
     SUM(CASE WHEN sad.lid=3 AND sad.sid=2 THEN sad.Nb ELSE 0 END) -- attributes
FROM salix.summary_of_databases AS sdb
JOIN salix.summary_of_advices AS sad
  ON (sdb.concerned_schema=sad.concerned_schema)
-- WHERE sad.cid <> 3 -- skip version-related advices
GROUP BY sdb.concerned_schema, sdb.table_count, sdb.attribute_count
ORDER BY sdb.concerned_schema;

-- floor
UPDATE salix.marks SET mark=0.0 WHERE mark<0.0;
