-- $Id: adv_dbversion.sql 2923 2012-01-07 09:58:29Z coelho $

-- ------------------------------------------------------------
-- Database Version Advices
-- ------------------------------------------------------------

CREATE TABLE salix.in_current_database_version AS

SELECT *
FROM salix.in_db_versions AS dbv
WHERE salix.software_info() ~ dbv.info_re
ORDER BY priority ASC
LIMIT 1;

--
-- MySQL Warning
--
-- VIEW
CREATE TABLE salix.dbva_database_is_mysql AS

SELECT *, ''::TEXT AS schema_name, ''::TEXT AS explanation
FROM salix.in_current_database_version AS cdv
WHERE cdv.name LIKE '%MySQL%';

--
-- MyISAM Warning On Table
--
-- VIEW
CREATE TABLE salix.dbva_table_engine_is_unsafe
( TSchema TEXT NOT NULL,
  TName TEXT NOT NULL,
  explanation TEXT NOT NULL,
  PRIMARY KEY (TSchema, TName)
);

--
-- MyISAM Warning On Schema
--
-- VIEW
CREATE TABLE salix.dbva_schema_engine_is_unsafe AS

SELECT
  teim.TSchema AS TSchema,
  CONCAT('schema ', teim.TSchema) AS explanation
FROM salix.dbva_table_engine_is_unsafe AS teim
GROUP BY teim.TSchema;

--
-- Engine inconsistency
--
-- VIEW
CREATE TABLE salix.in_table_engine_is_safe
( TSchema TEXT NOT NULL,
  TName TEXT NOT NULL,
  explanation TEXT NOT NULL,
  PRIMARY KEY (TSchema, TName)
);

CREATE TABLE salix.dbva_engine_inconsistency AS

SELECT
  teim.TSchema AS TSchema,
  CONCAT('schema ', teim.TSchema) AS explanation
FROM salix.dbva_table_engine_is_unsafe AS teim
JOIN salix.in_table_engine_is_safe AS teii
  ON teim.TSchema=teii.TSchema
GROUP BY teim.TSchema;

-- should be derived from pg_catalog?
CREATE TABLE salix.ca_cross_schema_indexes(
  IndexSchema TEXT NOT NULL,
  IndexName TEXT NOT NULL,
  TableSchema TEXT NOT NULL,
  TableName TEXT NOT NULL,
  explanation TEXT NOT NULL,
  PRIMARY KEY (IndexSchema, IndexName, TableSchema, TableName)
);
