-- $Id: adv_system.sql 2923 2012-01-07 09:58:29Z coelho $

CREATE TABLE salix.in_trivial_password AS
SELECT
	p.usename AS username,
	p.usecreatedb OR p.usesuper OR p.usecatupd AS is_su
FROM pg_catalog.pg_shadow AS p
WHERE p.passwd IS NULL
   OR p.passwd=''
   OR p.passwd=p.usename
   OR p.passwd='md5' || MD5(p.usename)
   OR p.passwd='md5' || MD5(p.usename||p.usename);

CREATE TABLE salix.sa_trivial_password_user AS
SELECT username, CONCAT('user ', username) AS explanation
FROM salix.in_trivial_password
WHERE NOT is_su;


CREATE TABLE salix.sa_trivial_password_superuser AS
SELECT username, CONCAT('user ', username) AS explanation
FROM salix.in_trivial_password
WHERE is_su;

--
-- MAATKIT http://www.maatkit.org/
-- mk-duplicate-key-checker
--  - Find duplicate indexes on MySQL tables.
--

CREATE TABLE salix.sa_redundant_indexes AS
SELECT nspname AS TSchema, relname AS TName, COUNT(*)-1 AS Nb,
  CONCAT('table ', nspname, '.', relname) AS explanation
FROM pg_catalog.pg_index AS i
JOIN pg_catalog.pg_class AS c ON (c.oid = i.indrelid)
JOIN pg_catalog.pg_namespace AS n ON (n.oid = c.relnamespace)
WHERE nspname <> ALL (SELECT name FROM salix.excluded_schemas)
-- conservative checking
-- - should check indkey prefixes?
-- - could ignore some fields?
-- ignored: isunique, isprimary, isclustered
GROUP BY nspname, relname, indkey, indclass, indoption, indexprs, indpred
HAVING COUNT(*) > 1;

--
-- From SchemaSpy
--
CREATE TABLE salix.sa_table_without_index AS
SELECT
  schemaname AS TSchema,
  tablename AS TName,
  CONCAT('table ', schemaname, '.', tablename) AS explanation
FROM pg_tables
WHERE schemaname <> ALL (SELECT name FROM salix.excluded_schemas)
AND NOT hasindexes;
