-- $Id: information_schema_copy.sql 2923 2012-01-07 09:58:29Z coelho $
-- the copy is created in current schema...

CREATE TABLE COLUMNS AS
SELECT * FROM information_schema.COLUMNS;
CREATE INDEX c_idx_table_schema ON COLUMNS (table_schema);
CREATE INDEX c_idx_table_name ON COLUMNS (table_name);
CREATE INDEX c_idx_column_name ON COLUMNS (column_name);

CREATE TABLE COLUMN_PRIVILEGES AS
SELECT * FROM information_schema.COLUMN_PRIVILEGES;

CREATE TABLE KEY_COLUMN_USAGE AS
SELECT * FROM information_schema.KEY_COLUMN_USAGE;
CREATE INDEX kcu_idx_constraint_schema ON KEY_COLUMN_USAGE (constraint_schema);
CREATE INDEX kcu_idx_constraint_name ON KEY_COLUMN_USAGE (constraint_name);
CREATE INDEX kcu_idx_table_schema ON KEY_COLUMN_USAGE (table_schema);
CREATE INDEX kcu_idx_table_name ON KEY_COLUMN_USAGE (table_name);
CREATE INDEX kcu_idx_column_name ON KEY_COLUMN_USAGE (column_name);

CREATE TABLE ROUTINES AS
SELECT * FROM information_schema.ROUTINES;

CREATE TABLE SCHEMATA AS
SELECT * FROM information_schema.SCHEMATA;

-- no
-- CREATE TABLE SCHEMA_PRIVILEGES AS
-- SELECT * FROM information_schema.SCHEMA_PRIVILEGES;

-- no
-- CREATE TABLE STATISTICS AS
-- SELECT * FROM information_schema.STATISTICS;

CREATE TABLE TABLES AS
SELECT * FROM information_schema.TABLES;
CREATE INDEX t_idx_table_schema ON TABLES (table_schema);
CREATE INDEX t_idx_table_name ON TABLES (table_name);

CREATE TABLE TABLE_CONSTRAINTS AS
SELECT * FROM information_schema.TABLE_CONSTRAINTS;
CREATE INDEX tc_idx_constraint_schema ON TABLE_CONSTRAINTS (constraint_schema);
CREATE INDEX tc_idx_constraint_name ON TABLE_CONSTRAINTS (constraint_name);
CREATE INDEX tc_idx_table_schema ON TABLE_CONSTRAINTS (table_schema);
CREATE INDEX tc_idx_table_name ON TABLE_CONSTRAINTS (table_name);

CREATE TABLE TABLE_PRIVILEGES AS
SELECT * FROM information_schema.TABLE_PRIVILEGES;

CREATE TABLE TRIGGERS AS
SELECT * FROM information_schema.TRIGGERS;

-- no
-- CREATE TABLE USER_PRIVILEGES AS
-- SELECT * FROM information_schema.USER_PRIVILEGES;

CREATE TABLE VIEWS AS
SELECT * FROM information_schema.VIEWS;

CREATE TABLE REFERENTIAL_CONSTRAINTS AS
SELECT * FROM information_schema.REFERENTIAL_CONSTRAINTS;

-- FULL seems over expensive in 9.0
-- VACUUM VERBOSE FULL ANALYZE;
VACUUM ANALYZE;
