--
-- $Id: utils.sql 2788 2011-01-28 14:00:04Z coelho $
--

-- mysql function compatibility
-- it seems that both anyelement must have the *same* type
CREATE OR REPLACE FUNCTION salix.ifnull(ANYELEMENT, ANYELEMENT)
RETURNS ANYELEMENT
IMMUTABLE CALLED ON NULL INPUT
AS $$ SELECT COALESCE($1, $2) $$
LANGUAGE SQL;

-- quick fix...
CREATE OR REPLACE FUNCTION salix.ifnull(BIGINT, INT)
RETURNS BIGINT
IMMUTABLE CALLED ON NULL INPUT
AS $$ SELECT COALESCE($1, $2)::BIGINT $$
LANGUAGE SQL;

--
-- Grabbing Current DB Name & Version
--
CREATE OR REPLACE FUNCTION salix.software_info() RETURNS VARCHAR(100)
IMMUTABLE STRICT
AS $$ SELECT VERSION() $$
LANGUAGE SQL;

--
-- regular expression encapsulation for My/Pg compatibility
--
CREATE OR REPLACE FUNCTION salix.regexpr(s TEXT, p TEXT) RETURNS BOOLEAN
IMMUTABLE STRICT
AS $$ SELECT $1 ~ $2 $$
LANGUAGE SQL;

--
-- string concatenation for My/Pg compatibility
--
CREATE OR REPLACE FUNCTION salix.concat(VARIADIC TEXT[]) RETURNS TEXT
IMMUTABLE STRICT
AS $$ SELECT array_to_string($1,'') $$
LANGUAGE SQL;

--
-- My/Pg compatible cast
--
CREATE OR REPLACE FUNCTION salix.textcast(ANYELEMENT) RETURNS TEXT
IMMUTABLE STRICT
AS $$ SELECT CAST($1 AS TEXT) $$
LANGUAGE SQL;

-- CREATE OR REPLACE FUNCTION salix.is_equal(a ANYELEMENT, b ANYELEMENT)
-- RETURNS BOOLEAN CALLED ON NULL INPUT AS $$
--   SELECT ($1 IS NULL AND $2 IS NULL)
--       OR ($1 IS NOT NULL AND $2 IS NOT NULL AND $1 = $2);
-- $$ LANGUAGE SQL;
